#!/bin/sh
#
# sdist.sh,v 1.5 2001/03/29 22:00:37 kim Exp
#
# David M. Siegel Mon Oct 26, 1992 at 10:30:29
# Kimmo Suominen 1995-05-20, 1996-02-16
# Christos Zoulas Wed Sep 18 16:32:58 EDT 1996
# Kimmo Suominen 1998-10-09, 1999-08-30

PATH=/usr/local/bin:/bin:/usr/bin:/usr/sbin:/usr/etc:/usr/ucb
PATH=${PATH}:@PREFIX@/bin:@PREFIX@/sbin
export PATH

maxkids=4
netgroup="dist-`osname`-`uname -m`"
servers="`netgroup $netgroup`"
any_servers="false"
destdir=
allmasters=
nomasters=
extras=
domain=`netname -d`
cwd=`@PAWD@`
RSH=rsh
# OPTS gets passed along via RSH in an 'sdist -A'
OPTS=
# default timeout for rdist -- 2 minutes instead of 15
timeout=120


while [ "$1" != "" ]; do
	case "$1" in
	-[rR])	OPTS="$OPTS -R"
		rdistopts="$rdistopts -R"
		;;
	-[yqvnz]) OPTS="$OPTS $1"
		rdistopts="$rdistopts $1"
		;;
	-[od])	OPTS="$OPTS $1 $2"
		rdistopts="$rdistopts $1 $2"
		shift
		;;
	-t) OPTS="$OPTS $1 $2"
		timeout=$2
		shift
		;;
	-M)	OPTS="$OPTS $1 $2"
		maxkids="$2"
		shift
		;;
	-f) 	OPTS="$OPTS $1 $2"
		if [ "$any_servers" = "false" ]; then
			any_servers="true"
			servers=""
		fi
		if [ ! -s $2 ]; then
			echo "$0: No file $2" 2>&1
			exit 1
		fi
		for i in `cat $2`
		do
			x=`netgroup $i`
			case "$x" in
			'')	# Must be a hostname
				x=$i
				;;
			*)	# Aha, was a netgroup after all
				;;
			esac
			servers="$servers $x"
		done
		shift
		;;
	-h) 	OPTS="$OPTS $1 $2"
		if [ "$any_servers" = "false" ]; then
			any_servers="true"
			servers=""
		fi
		x=`netgroup $2`
		case "$x" in
		'')	# Must be a hostname
			x=$2
			;;
		*)	# Aha, was a netgroup after all
			;;
		esac
		servers="$servers $x"
		shift
		;;
	-A)	# Don't propagate -A
		remote=`netgroup $netgroup-masters`
		servers="$servers $remote"

		if [ -z "$remote" ]
		then
			echo "$0: No netgroup $netgroup-masters" 2>&1
			exit 1
		fi
		# pull current domain out of list of domains-to-push-to
		allmasters=
		for i in $remote
		do
			if [ "`netname -d $i`" = $domain ]
			then
				:
			else
				allmasters="$allmasters $i"
			fi
		done
		;;
	-x)	OPTS="$OPTS $1 '$2'"
		extras="$extras $2 ; "
		shift;
		;;
	-D)	OPTS="$OPTS $1 $2"
		destdir=$2
		shift
		;;
	-[sS])	OPTS="$OPTS $1"
		export RDIST_RSH
		RDIST_RSH=@SRSH@
		RSH=ssh
		rdistopts="$rdistopts -P @SRSH@"
		;;
	*)      break
		;;
	esac
	shift	
done

if [ -z "$servers" ]
then
	echo "$0: No netgroup $netgroup to get default servers" 1>&2
	exit 1
fi

case $# in
0)	set x $cwd; shift;;
esac

for directory
do
	case "$destdir" in
	'')	case "$directory" in
		/*)	;;
		*)	directory="$cwd/$directory";;
		esac
		;;
	*)	;;
	esac
	dirs="$dirs $directory"
done

# Use an rdist file for multiple directories and parallel updates.
@RDIST@ -t $timeout -M $maxkids $rdistopts -f - << __EOF || exit $?
	($dirs)	-> ($servers $allmasters)
		$extras
		install $destdir ;
		notify logs-rdist ;
__EOF

if [ ! -z "$allmasters" ]
then
	for i in $allmasters
	do
		echo "Initiatiating remote updates to $i"
		$RSH -n $i "sdist $OPTS $dirs" || exit $?
	done
	wait
fi

exit 0
